"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const component_tree_context_1 = require("./component-tree-context");
const indent_1 = require("./indent");
const inflate_paths_1 = require("./inflate-paths");
const payload_type_1 = require("./payload-type");
const recursive_tree_1 = require("./recursive-tree");
const root_node_1 = require("./root-node");
const default_tree_node_renderer_1 = require("./default-tree-node-renderer");
function ComponentTree({ components, onSelect, selected, TreeNode = default_tree_node_renderer_1.DefaultTreeNodeRenderer, }) {
    const rootNode = react_1.useMemo(() => {
        const tree = inflate_paths_1.inflateToTree(components, (c) => c.id.toString({ ignoreVersion: true }));
        const payloadMap = calcPayload(components);
        inflate_paths_1.attachPayload(tree, payloadMap);
        return tree;
    }, [components]);
    return (react_1.default.createElement("div", { style: indent_1.indentStyle(1) },
        react_1.default.createElement(recursive_tree_1.TreeNodeContext.Provider, { value: TreeNode },
            react_1.default.createElement(component_tree_context_1.ComponentTreeContextProvider, { onSelect: onSelect, selected: selected },
                react_1.default.createElement(root_node_1.RootNode, { node: rootNode, depth: 1 })))));
}
exports.ComponentTree = ComponentTree;
function calcPayload(components) {
    const payloadMap = new Map(components.map((c) => [c.id.toString({ ignoreVersion: true }), c]));
    const scopeIds = new Set(components.map((x) => x.id.scope).filter((x) => !!x));
    scopeIds.forEach((x) => x && payloadMap.set(`${x}/`, new payload_type_1.ScopePayload()));
    return payloadMap;
}
//# sourceMappingURL=component-tree.js.map